package prevoz;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.Optional;
import java.util.stream.Stream;

public class GSP {
	
	private Map<String, Linija> linije = new HashMap<>();
	private Map<Integer, Stajaliste> stajalista = new HashMap<>();
	
	private static GSP instance;
	
	private GSP() {}
	
	public static GSP getInstance() {
		if(instance == null) {
			instance = new GSP();
		}
		return instance;
	}
	
	public void ucitaj(File file) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(file));
			Stream<String> s = br.lines();
			
			s.forEach(l->{
				Linija lin = Linija.parsiraj(l);
				linije.put(lin.naziv(), lin);
				
				String fileName = file.getParent()+"\\linija_"+lin.naziv()+".txt";
				try {
					BufferedReader brs = new BufferedReader(new FileReader(fileName));
					Stream<String> ss = brs.lines();
					
					ss.forEach(stop->{
						Stajaliste stajaliste = Stajaliste.parsiraj(stop);
						lin.dodaj(stajaliste);
						stajalista.put(stajaliste.broj(), stajaliste);
					});
					
					brs.close();
					
				} catch (FileNotFoundException e) {
					System.err.println("Fajl nije pronadjen...");
				} catch (IOException e) {
				}
			});
			
			br.close();
		} catch (FileNotFoundException e) {
			System.err.println("Fajl nije pronadjen...");
		} catch (IOException e) {
		}
	}

	private void uradi(Stajaliste s) {
		System.out.println(s);
	}
	
	public void ispisi() {
		linije.values().stream().forEach(System.out::println);
		stajalista.values().stream().forEach(this::uradi);
	}
	
	public void najduzaLinija(int zona) {
		Optional<Linija> max = linije.values().stream()
					.filter(l->{ return l.stajalista().stream().allMatch(s->{return s.zona()==zona;});})
					.max((l1, l2)->l1.stajalista().size()-l2.stajalista().size());
		System.out.println("\nNajduza linija koja saobraca samo u prvoj zoni je:");
		System.out.println(max.isPresent()?max.get():"---");
	}
}
