package prevoz;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class Linija {
	private String naziv;
	private String smerA, smerB;
	private List<Stajaliste> stajalista = new ArrayList<>();
	
	/**
	 * @param naziv Naziv linije
	 * @param smerA Pocetno stajaliste u smeru A
	 * @param smerB Pocetno stajaliste u smeru B
	 */
	public Linija(String naziv, String smerA, String smerB) {
		super();
		this.naziv = naziv;
		this.smerA = smerA;
		this.smerB = smerB;
	}
	
	/**
	 * Dodaje stajaliste s u listu stajalista kroz koja linija prolazi
	 * @param s Stajaliste koje se dodaje
	 */
	public void dodaj(Stajaliste s) {
		this.stajalista.add(s);
	}
	
	public String naziv() {
		return naziv;
	}
	
	public List<Stajaliste> stajalista(){return stajalista;}
	
	/**
	 * Parsira podatke o liniji iz zadatog teksta
	 * @param s Tekst iz koga je potrebno parsirati podatke o liniji
	 * @return Parsirana linija
	 */
	public static Linija parsiraj(String s) {
		Linija l = null;
		
		Pattern p = Pattern.compile("^(.*);(.*);(.*);$");
		Matcher m = p.matcher(s);
		if(m.matches()) {
			String naziv = m.group(1);
			String smerA = m.group(2);
			String smerB = m.group(3);
			
			l = new Linija(naziv, smerA, smerB);
		}
		return l;
	}
	
	@Override
	public String toString() {
		return String.format("%5s  %15s - %s", naziv, smerA, smerB);
	}
}
