package prevoz;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class Stajaliste {
	private int broj;
	private String naziv;
	private int zona;
	
	public Stajaliste(int broj, String naziv,  int zona) {
		super();
		this.broj = broj;
		this.naziv = naziv;
		this.zona = zona;
	}
	
	public int broj() { return broj; }
	public int zona() { return zona; }
	

	public static Stajaliste parsiraj(String str) {
		Stajaliste s = null;
		Pattern p = Pattern.compile("^.*\"(.*) \\[#(.*)\\].*,(.)\\];$");
		Matcher m = p.matcher(str);
		if(m.matches()) {
			int broj = Integer.parseInt(m.group(2));
			String naziv = m.group(1);
			int zona = Integer.parseInt(m.group(3));
			s = new Stajaliste(broj, naziv, zona);
		}
		return s;
	}
	
	@Override
	public String toString() {
		return String.format("%4d [%d]  %s ", broj, zona, naziv);
	}
}
